#!/usr/bin/python
# -*- coding: utf-8 -*-
# title           : _laliga_match
# python_version  : Python 3.7.0
# ==============================================================================
# ==============================================================================
'''                             _laliga_match                               '''
# ==============================================================================
# ==============================================================================
import requests
import time  # sleep
import requests
import bs4
import re
import yaml  # pretty print
import datetime
import json

'''------------------------------------------------------------------------------------------------------------------------------'''


def cleanhtml(raw_html):
    cleanr = re.compile('<.*?>')
    cleantext = re.sub(cleanr, '', raw_html)
    return cleantext


def composed_team_name(line):
    line = line.replace('Rayo Vallecano', 'Rayo-Vallecano') \
        .replace('Real Madrid', 'Real-Madrid') \
        .replace('Real Valladolid', 'Valladolid') \
        .replace('Real Betis', 'Betis') \
        .replace('Real Sociedad', 'Real-Sociedad') \
        .replace('R. Sociedad', 'Real-Sociedad') \
        .replace('Atlético Madrid', 'Atlético-Madrid') \
        .replace('Atlético Osasuna', 'Osasuna') \
        .replace('Las Palmas', 'Las-Palmas') \
        .replace('Granada CF', 'Granada') \
        .replace('Real Sporting', 'Sporting') \
        .replace('Real Zaragoza', 'Zaragoza') \
        .replace('Racing', 'Racing-Santander') \
        .replace('Real Murcia', 'Murcia') \
        .replace('Real Oviedo', 'Real-Oviedo') \
        .replace('CF Extremadura', 'CF-Extremadura') \
        .replace('Mérida CP', 'Mérida-CP') \
        .replace('CD Logroñés', 'CD-Logroñés') \
        .replace('Real Burgos CF', 'Burgos') \
        .replace('Gimnàstic Tarragona', 'Gimnàstic-Tarragona') \
        .replace('CD Castellón', 'CD-Castellón') \
        .replace('CD Málaga', 'Málaga') \
        .replace('Almeria AD', 'Almería') \
        .replace(' *', '')
    if line == 'Atlético':
        line = line.replace('Atlético', 'Atlético-Madrid')
    if line == 'Athletic':
        line = line.replace('Athletic', 'Athletic-Bilbao')
    if line == 'Sporting':
        line = line.replace('Sporting', 'Sporting-Gijón')
    return line


def get_matchdata(url, team1, team2, date, matchdays_num_num, season_num):
    print(url)
    season_year_past = int(season_num)-1
    # season_year = int(url[-4:])
    url_match_req = requests.get(url)
    status = str(url_match_req.status_code)
    # soup
    soup_match = bs4.BeautifulSoup(url_match_req.content, 'html.parser')
    # soup_match=bs4.BeautifulSoup(url_match_req.text, 'lxml')
    status_info = str(soup_match.find(id='tab_match_teams'))
    # CHECK STATUS INFO

    if status_info == 'None':
        status_info = 'NO DATA'
        print(status_info)
        print(team1 + '\t' + team2)

        return status_info
    else:
        match_datamatch = soup_match.find(id='tab_match_teams')
        match_header = soup_match.find_all('div', {'class': 'report-resume-header'})
        tab_match_teams = match_datamatch.find_all('div', {'class': 'team team1'})

        # match date
        match_date = str(soup_match.find_all('span', {'class': 'jor-date'}))
        match_date = match_date[match_date.find('content="') + len('content="'):]
        match_date = match_date[:match_date.find('"')]
        match_date_year = str(match_date[0:4])
        match_date_month = str(match_date[5:7])
        match_date_day = str(match_date[8:10])
        match_date_hour = str(match_date[11:13])
        match_date_minute = str(match_date[14:16])

        # timeline info
        match_timeline = soup_match.find(id='listado_eventos')

        # match_header
        match_header = cleanhtml(str(match_header))
        match_header = match_header.split('\n')
        # teams
        tab_match_teams_team1_name = str()
        tab_match_teams_team2_name = str()
        # stadium
        # tab_match_teams_stadium = str()
        # coaches
        tab_match_teams_team1_coach = str()
        tab_match_teams_team2_coach = str()
        # referee
        tab_match_teams_referee = str()

        # match score
        tab_match_score = cleanhtml(str(soup_match.find_all('div', {'class': 'resultado resultadoH'})))\
            .replace('[','')\
            .replace(']','')
        tab_match_score_team1 = tab_match_score[:tab_match_score.find('-')]
        tab_match_score_team2 = tab_match_score[tab_match_score.find('-')+len('-'):]

        try:
            # teams
            tab_match_teams_team1_name = composed_team_name(match_header[14])
            tab_match_teams_team2_name = composed_team_name(match_header[22])
            # stadium
            # tab_match_teams_stadium = match_header[28][match_header[28].find(':') + 2:]
            # coaches
            tab_match_teams_team1_coach = match_header[51]
            tab_match_teams_team2_coach = match_header[60]
            # referee
            tab_match_teams_referee = match_header[54]
        except:
            pass

        # teams
        tab_match_teams_team1_name = str(soup_match.find_all('div', {'class': 'team equipo1'}))
        tab_match_teams_team1_name = cleanhtml(tab_match_teams_team1_name[
                                               tab_match_teams_team1_name.find('<h2>'):tab_match_teams_team1_name.find(
                                                   '</h2>')])
        tab_match_teams_team2_name = str(soup_match.find_all('div', {'class': 'team equipo2'}))
        tab_match_teams_team2_name = cleanhtml(tab_match_teams_team2_name[
                                               tab_match_teams_team2_name.find('<h2>'):tab_match_teams_team2_name.find(
                                                   '</h2>')])
        tab_match_teams_team1_name = composed_team_name(tab_match_teams_team1_name)
        tab_match_teams_team2_name = composed_team_name(tab_match_teams_team2_name)

        # stadium & attendance
        tab_match_teams_stadium_attendance = str(soup_match.find_all('div', {'class': 'matchinfo'}))
        tab_match_teams_stadium = tab_match_teams_stadium_attendance[
                                  tab_match_teams_stadium_attendance.find('<span itemprop="name">Estadio: ') + len(
                                      '<span itemprop="name">Estadio: '):]
        tab_match_teams_stadium = tab_match_teams_stadium[:tab_match_teams_stadium.find('</span>')]
        tab_match_teams_attendance = tab_match_teams_stadium_attendance[tab_match_teams_stadium_attendance.find(
            '<span itemprop="attendees">Asistencia: ') + len('<span itemprop="attendees">Asistencia: '):]
        tab_match_teams_attendance = tab_match_teams_attendance[:tab_match_teams_attendance.find('</span>')]
        tab_match_teams_attendance_digit = list()
        for x in tab_match_teams_attendance:
            if x.isdigit():
                tab_match_teams_attendance_digit.append(x)
        if len(tab_match_teams_attendance_digit) is not 0:
            tab_match_teams_attendance_digit = int(''.join(tab_match_teams_attendance_digit))
        else:
            tab_match_teams_attendance_digit = 0

        # formations
        tab_match_teams_team1_formation = composed_team_name(
            cleanhtml(str(match_datamatch.find_all('small', {'class': 'align-code'})))[1:-1]).split(',')
        formation_team1 = tab_match_teams_team1_formation[0]
        formation_team2 = tab_match_teams_team1_formation[1][1:]
        # aligns
        tab_match_teams_aligns = match_datamatch.find_all('ul', {'class': 'aligns-list'})
        tab_match_teams_aligns_mainalign_team1 = str()
        tab_match_teams_aligns_supalign_team1 = str()
        tab_match_teams_aligns_mainalign_team2 = str()
        tab_match_teams_aligns_supalign_team2 = str()

        # remove <b title="Goles">_</b></span>
        def remove_goals_labels(align_str):
            # if len(align_str.find('<b title="Goles">')) > 1:
            #     new_align_str = align_str[:align_str.find('<b title="Goles">')[0]]
            #     new_align2_str = align_str[align_str.find('<b title="Goles">')[0]:]
            #     new_align2_str = new_align2_str[new_align2_str.find('</b>')[0]:]
            #     new_align_final_str = new_align_str + new_align2_str
            #     remove_goals_labels(new_align_final_str)
            new_align_str = align_str[:align_str.find('<b title="Goles">')]
            new_align2_str = align_str[align_str.find('<b title="Goles">'):]
            new_align2_str = new_align2_str[new_align2_str.find('</b>'):]
            new_align_final_str = new_align_str + new_align2_str
            return cleanhtml(new_align_final_str)

        try:
            tab_match_teams_aligns_mainalign_team1 = str(tab_match_teams_aligns[0])
            # print(tab_match_teams_aligns_mainalign_team1.find('<b title="Goles">'))
            if tab_match_teams_aligns_mainalign_team1.find('<b title="Goles">') is not -1:
                tab_match_teams_aligns_mainalign_team1 = remove_goals_labels(tab_match_teams_aligns_mainalign_team1)
            else:
                tab_match_teams_aligns_mainalign_team1 = cleanhtml(tab_match_teams_aligns_mainalign_team1)
            # print(tab_match_teams_aligns_mainalign_team1)
        except:
            pass
        try:
            tab_match_teams_aligns_supalign_team1 = str(tab_match_teams_aligns[1])
            if tab_match_teams_aligns_supalign_team1.find('<b title="Goles">') is not -1:
                tab_match_teams_aligns_supalign_team1 = remove_goals_labels(tab_match_teams_aligns_supalign_team1)
            else:
                tab_match_teams_aligns_supalign_team1 = cleanhtml(tab_match_teams_aligns_supalign_team1)
            # print(tab_match_teams_aligns_supalign_team1)
        except:
            pass
        try:
            tab_match_teams_aligns_mainalign_team2 = cleanhtml(str(tab_match_teams_aligns[2]))
            if tab_match_teams_aligns_mainalign_team2.find('<b title="Goles">') is not -1:
                tab_match_teams_aligns_mainalign_team2 = remove_goals_labels(tab_match_teams_aligns_mainalign_team2)
            else:
                tab_match_teams_aligns_mainalign_team2 = cleanhtml(tab_match_teams_aligns_mainalign_team2)
            # print(tab_match_teams_aligns_mainalign_team2)
        except:
            pass
        try:
            tab_match_teams_aligns_supalign_team2 = str(tab_match_teams_aligns[3])
            if tab_match_teams_aligns_supalign_team2.find('<b title="Goles">') is not -1:
                tab_match_teams_aligns_supalign_team2 = remove_goals_labels(tab_match_teams_aligns_supalign_team2)
            else:
                tab_match_teams_aligns_supalign_team2 = cleanhtml(tab_match_teams_aligns_supalign_team2)
            # print(tab_match_teams_aligns_supalign_team2)
        except:
            pass

        # parsealigns
        def get_align(raw_list):
            numbers = list()
            names = list()
            raw_list = raw_list.split('\n')
            raw_list = list(filter(None, raw_list))
            for x in raw_list:
                if x.isdigit(): numbers.append(x)
                elif not str(x).strip()[0:1].isdigit() and str(x) != ' ': names.append(x)
            # ok
            if len(numbers) == len(names):
                list_number_names = list(zip(numbers, names))
                return names
            # ko
            else:
                numbers = list()
                names_clean = list()
                for x in names:
                    if(x != '\xa0'):
                        numbers.append(0)
                        names_clean.append(x)
                list_number_names = list(zip(numbers, names_clean))
                return names_clean

        # main align team 1
        tab_match_teams_aligns_mainalign_team1 = get_align(tab_match_teams_aligns_mainalign_team1)
        # sup align team 1
        tab_match_teams_aligns_supalign_team1 = get_align(tab_match_teams_aligns_supalign_team1)
        # main align team 2
        tab_match_teams_aligns_mainalign_team2 = get_align(tab_match_teams_aligns_mainalign_team2)
        # sup align team 2
        tab_match_teams_aligns_supalign_team2 = get_align(tab_match_teams_aligns_supalign_team2)

        # aligns order
        # align1main - align2main - align1/2sup
        if len(tab_match_teams_aligns) == 3:
            # align1main - NULL - align2main - align2sup
            if len(tab_match_teams_aligns_mainalign_team1) == 11 and len(tab_match_teams_aligns_supalign_team1) == 11:
                tab_match_teams_aligns_supalign_team2 = tab_match_teams_aligns_mainalign_team2
                tab_match_teams_aligns_mainalign_team2 = tab_match_teams_aligns_supalign_team1
                tab_match_teams_aligns_supalign_team1 = list()
            # align1main - align1sup - align2main - NULL
            elif len(tab_match_teams_aligns_mainalign_team1) == 11 and len(tab_match_teams_aligns_mainalign_team2) == 11:
                tab_match_teams_aligns_supalign_team2 = list()
        # align1main - align2main
        if len(tab_match_teams_aligns) == 2:
            if len(tab_match_teams_aligns_mainalign_team1) == 11 and len(tab_match_teams_aligns_supalign_team1) == 11:
                tab_match_teams_aligns_mainalign_team2 = tab_match_teams_aligns_supalign_team1
                tab_match_teams_aligns_supalign_team1 = list()
                tab_match_teams_aligns_supalign_team2 = list()

        # events
        events_raw = str(match_timeline.find_all('div', {'class': 'event-content'})).split(',')
        events_team1 = list()
        events_team2 = list()

        def get_events(rawevents):
            ev_team1_type = list()
            ev_team1_player = list()
            ev_team1_minute = list()
            ev_team2_type = list()
            ev_team2_player = list()
            ev_team2_minute = list()

            for e in rawevents:
                ev_left = e[e.find('<span class="left'):e.find('</span>')]
                ev_left = ev_left[len('<span class="left') + 2:]
                ev_right = e[e.find('<span class="right'):]
                ev_right = ev_right[len('<span class="right'):]

                if ev_left != '':
                    # type
                    ev_left_type = ev_left[ev_left.find('<small>') + len('<small>'):ev_left.find('</small>')]
                    # minute
                    ev_left_minute = e[e.find('<b>minuto</b> ') + len('<b>minuto</b> '):]
                    ev_left_minute = ev_left_minute[:ev_left_minute.find('\'')]
                    # player
                    ev_left_player = cleanhtml(
                        ev_left[ev_left.find('<h5 class="name">') + len('<h5 class="name">'):ev_left.find('</h5>'):])
                    if ev_left_player.find('>') is not -1:
                        ev_left_player = ev_left_player[ev_left_player.find('>') + 1:]
                    if ev_left_player.find('<') is not -1:
                        ev_left_player = ev_left_player[:ev_left_player.find('<')]
                    ev_left_player = cleanhtml(ev_left_player.strip())

                    # yellow card
                    if ev_left_type == 'T. Amarilla':
                        ev_team1_type.append('yellow card')
                        ev_team1_minute.append(ev_left_minute)
                        ev_team1_player.append(ev_left_player)
                    # 2nd yellow card
                    elif ev_left_type == '2a Amarilla y Roja':
                        ev_team1_type.append('red card (2nd yellow)')
                        ev_team1_minute.append(ev_left_minute)
                        ev_team1_player.append(ev_left_player)
                    # red card
                    elif ev_left_type == 'Tarjeta Roja a ':
                        ev_team1_type.append('red card')
                        ev_team1_minute.append(ev_left_minute)
                        ev_team1_player.append(ev_left_player)
                    # goal
                    elif ev_left_type == 'Gol de ':
                        ev_team1_type.append('goal')
                        ev_team1_minute.append(ev_left_minute)
                        ev_team1_player.append(ev_left_player)
                    # penalty goal
                    elif ev_left_type == 'Gol de penalti':
                        ev_team1_type.append('goal penalty')
                        ev_team1_minute.append(ev_left_minute)
                        ev_team1_player.append(ev_left_player)
                    # own goal
                    elif ev_left_type == 'Gol de <i title="Gol en propia puerta">(p.p)</i>':
                        ev_team1_type.append('goal own')
                        ev_left_minute = ev_left_minute[ev_left_minute.find('<b>minuto</b>') + len('<b>minuto</b>'):]
                        ev_team1_minute.append(ev_left_minute)
                        ev_team1_player.append(ev_left_player)
                    # cancelled goal
                    elif ev_left_type == 'Gol anulado':
                        ev_team1_type.append('goal cancelled')
                        ev_team1_minute.append(ev_left_minute)
                        ev_team1_player.append(ev_left_player)
                    # free kick goal
                    elif ev_left_type == 'Gol de falta':
                        ev_team1_type.append('goal free-kick')
                        ev_team1_minute.append(ev_left_minute)
                        ev_team1_player.append(ev_left_player)
                    # cancelled VAR goal
                    elif ev_left_type == 'Anulado por var':
                        ev_team1_type.append('goal cancelled')
                        ev_team1_minute.append(ev_left_minute)
                        ev_team1_player.append(ev_left_player)
                    # post
                    elif ev_left_type == 'Tiro al palo':
                        ev_team1_type.append('post')
                        ev_team1_minute.append(ev_left_minute)
                        ev_team1_player.append(ev_left_player)
                    # penalty missed
                    elif ev_left_type == 'Penalti fallado':
                        ev_team1_type.append('missed penalty')
                        ev_team1_minute.append(ev_left_minute)
                        ev_team1_player.append(ev_left_player)
                    # penalty save
                    elif ev_left_type == 'Penalti parado':
                        ev_team1_type.append('saved penalty')
                        ev_team1_minute.append(ev_left_minute)
                        ev_team1_player.append(ev_left_player)
                    # assist
                    elif ev_left_type == 'Asistencia':
                        ev_team1_type.append('assist')
                        ev_team1_minute.append(ev_left_minute)
                        ev_team1_player.append(ev_left_player)
                    # injury
                    elif ev_left_type == 'Lesionado':
                        ev_team1_type.append('injury')
                        ev_team1_minute.append(ev_left_minute)
                        ev_team1_player.append(ev_left_player)
                    # substitutions
                    elif ev_left_type == 'Entra en el partido':
                        ev_team1_type.append('in')
                        ev_team1_minute.append(ev_left_minute)
                        ev_team1_player.append(ev_left_player)
                    elif ev_left_type == 'Sale del partido':
                        ev_team1_type.append('out')
                        ev_team1_minute.append(ev_left_minute)
                        ev_team1_player.append(ev_left_player)
                    # exception
                    else:
                        if (ev_left_type != 'an></div') and (ev_left_type != 'an></div>') and (
                                ev_left_type != 'an>\n</div'):
                            print('EVENT 1 TYPE ERROR')
                            print(ev_left_type)
                            print(ev_left_player)
                            print(ev_left_minute)
                            print()

                if ev_right != '':
                    # type
                    ev_right_type = ev_right[ev_right.find('<small>') + len('<small>'):ev_right.find('</small>')]
                    # minute
                    ev_right_minute = e[e.find('<b>minuto</b> ') + len('<b>minuto</b> '):]
                    ev_right_minute = ev_right_minute[:ev_right_minute.find('\'')]
                    # player
                    ev_right_player = ev_right[
                                      ev_right.find('<h5 class="name">') + len('<h5 class="name">'):ev_right.find(
                                          '</h5>'):]
                    ev_right_player = ev_right_player[ev_right_player.find('<a href="/jugador/'):ev_right_player.find(
                        '</a></span></div')]

                    if ev_right_player.find('>') is not -1:
                        ev_right_player = ev_right_player[ev_right_player.find('>') + 1:]
                    if ev_right_player.find('<') is not -1:
                        ev_right_player = ev_right_player[:ev_right_player.find('<')]
                    ev_right_player = cleanhtml(ev_right_player.strip())

                    # yellow card
                    if ev_right_type == 'T. Amarilla':
                        ev_team2_type.append('yellow card')
                        ev_team2_minute.append(ev_right_minute)
                        ev_team2_player.append(ev_right_player)
                    # 2nd yellow card
                    elif ev_right_type == '2a Amarilla y Roja':
                        ev_team2_type.append('red card (2nd yellow)')
                        ev_team2_minute.append(ev_right_minute)
                        ev_team2_player.append(ev_right_player)
                    # red card
                    elif ev_right_type == 'Tarjeta Roja a ':
                        ev_team2_type.append('red card')
                        ev_team2_minute.append(ev_right_minute)
                        ev_team2_player.append(ev_right_player)
                    # goal
                    elif ev_right_type == 'Gol de ':
                        ev_team2_type.append('goal')
                        ev_team2_minute.append(ev_right_minute)
                        ev_team2_player.append(ev_right_player)
                    # penalty goal
                    elif ev_right_type == 'Gol de penalti':
                        ev_team2_type.append('goal penalty')
                        ev_team2_minute.append(ev_right_minute)
                        ev_team2_player.append(ev_right_player)
                    # own goal
                    elif ev_right_type == 'Gol de <i title="Gol en propia puerta">(p.p)</i>':
                        ev_team2_type.append('goal own')
                        # ev_right_minute = ev_right_minute[ev_right_minute.find('<b>minuto</b>') + len('<b>minuto</b>'):]
                        ev_team2_minute.append(ev_right_minute)
                        ev_team2_player.append(ev_right_player)
                    # cancelled goal
                    elif ev_right_type == 'Gol anulado':
                        ev_team2_type.append('goal cancelled')
                        ev_team2_minute.append(ev_right_minute)
                        ev_team2_player.append(ev_right_player)
                    # free kick goal
                    elif ev_right_type == 'Gol de falta':
                        ev_team2_type.append('goal free-kick')
                        ev_team2_minute.append(ev_right_minute)
                        ev_team2_player.append(ev_right_player)
                    # cancelled VAR goal
                    elif ev_right_type == 'Anulado por var':
                        ev_team2_type.append('goal cancelled')
                        ev_team2_minute.append(ev_right_minute)
                        ev_team2_player.append(ev_right_player)
                    # post
                    elif ev_right_type == 'Tiro al palo':
                        ev_team2_type.append('post')
                        ev_team2_minute.append(ev_right_minute)
                        ev_team2_player.append(ev_right_player)
                    # penalty missed
                    elif ev_right_type == 'Penalti fallado':
                        ev_team2_type.append('missed penalty')
                        ev_team2_minute.append(ev_right_minute)
                        ev_team2_player.append(ev_right_player)
                    # penalty save
                    elif ev_right_type == 'Penalti parado':
                        ev_team2_type.append('saved penalty')
                        ev_team2_minute.append(ev_right_minute)
                        ev_team2_player.append(ev_right_player)
                    # assist
                    elif ev_right_type == 'Asistencia':
                        ev_team2_type.append('assist')
                        ev_team2_minute.append(ev_right_minute)
                        ev_team2_player.append(ev_right_player)
                    # injury
                    elif ev_right_type == 'Lesionado':
                        ev_team2_type.append('injury')
                        ev_team2_minute.append(ev_right_minute)
                        ev_team2_player.append(ev_right_player)
                    # substitutions
                    elif ev_right_type == 'Entra en el partido':
                        ev_team2_type.append('in')
                        ev_team2_minute.append(ev_right_minute)
                        ev_team2_player.append(ev_right_player)
                    elif ev_right_type == 'Sale del partido':
                        ev_team2_type.append('out')
                        ev_team2_minute.append(ev_right_minute)
                        ev_team2_player.append(ev_right_player)
                    # exception
                    else:
                        if (ev_right_type != 'an></div') and (ev_right_type != 'an></div>') and (
                                ev_right_type != 'an>\n</div'):
                            print('EVENT 2 TYPE ERROR')
                            print(ev_right_type)
                            print(ev_right_player)
                            print(ev_right_minute)
                            print()

            ev_team1 = list(zip(ev_team1_type, ev_team1_player, ev_team1_minute))
            ev_team2 = list(zip(ev_team2_type, ev_team2_player, ev_team2_minute))

            return ev_team1, ev_team2

        # get statistics
        match_statistics = soup_match.find(id='box-tabla')
        match_statistics = match_statistics.find_all('tr', {'class': 'barstyle bar4'})

        def get_statistics(rawstats):
            rawstats = str(rawstats)
            rawstats_split = rawstats.split('<tr class="barstyle bar4">')
            rawstats_split.pop(0)
            rawstats_splitclean = list()
            for x in rawstats_split:
                rawstats_clean = cleanhtml(str(x)).split('\n')
                rawstats_clean.pop(0)
                rawstats_clean.pop(3)
                rawstats_splitclean.append(rawstats_clean)

            # teams names
            stats_team1_teamname = tab_match_teams_team1_name
            stats_team2_teamname = tab_match_teams_team2_name
            # teams statistics
            stats_team1_possession = float()
            stats_team2_possession = float()
            stats_team1_goals = int()
            stats_team2_goals = int()
            stats_team1_shootsontarget = int()
            stats_team2_shootsontarget = int()
            stats_team1_shootsofftarget = int()
            stats_team2_shootsofftarget = int()
            stats_team1_totalshoots = int()
            stats_team2_totalshoots = int()
            stats_team1_goalkeepersaves = int()
            stats_team2_goalkeepersaves = int()
            stats_team1_cornerkicks = int()
            stats_team2_cornerkicks = int()
            stats_team1_offsides = int()
            stats_team2_offsides = int()
            stats_team1_yellowcards = int()
            stats_team2_yellowcards = int()
            stats_team1_redcards = int()
            stats_team2_redcards = int()
            stats_team1_assists = int()
            stats_team2_assists = int()
            stats_team1_posts = int()
            stats_team2_posts = int()
            stats_team1_injuries = int()
            stats_team2_injuries = int()
            stats_team1_subs = int()
            stats_team2_subs = int()
            stats_team1_fouls = int()
            stats_team2_fouls = int()

            for stats in rawstats_splitclean:
                if stats[1] == 'Posesión del balón':
                    stats_team1_possession = float(stats[0][:stats[0].find('%')])
                    stats_team2_possession = float(stats[2][:stats[2].find('%')])
                elif stats[1] == 'Goles':
                    stats_team1_goals = int(stats[0])
                    stats_team2_goals = int(stats[2])
                elif stats[1] == 'Tiros a puerta':
                    stats_team1_shootsontarget = int(stats[0])
                    stats_team2_shootsontarget = int(stats[2])
                elif stats[1] == 'Tiros fuera':
                    stats_team1_shootsofftarget = int(stats[0])
                    stats_team2_shootsofftarget = int(stats[2])
                elif stats[1] == 'Total tiros':
                    stats_team1_totalshoots = int(stats[0])
                    stats_team2_totalshoots = int(stats[2])
                elif stats[1] == 'Paradas del portero':
                    stats_team1_goalkeepersaves = int(stats[0])
                    stats_team2_goalkeepersaves = int(stats[2])
                elif stats[1] == 'Saques de esquina':
                    stats_team1_cornerkicks = int(stats[0])
                    stats_team2_cornerkicks = int(stats[2])
                elif stats[1] == 'Fueras de juego':
                    stats_team1_offsides = int(stats[0])
                    stats_team2_offsides = int(stats[2])
                elif stats[1] == 'Tarjetas Amarillas':
                    stats_team1_yellowcards = int(stats[0])
                    stats_team2_yellowcards = int(stats[2])
                elif stats[1] == 'Tarjetas Rojas':
                    stats_team1_redcards = int(stats[0])
                    stats_team2_redcards = int(stats[2])
                elif stats[1] == 'Asistencias':
                    stats_team1_assists = int(stats[0])
                    stats_team2_assists = int(stats[2])
                elif stats[1] == 'Tiros al palo':
                    stats_team1_posts = int(stats[0])
                    stats_team2_posts = int(stats[2])
                elif stats[1] == 'Lesiones':
                    stats_team1_injuries = int(stats[0])
                    stats_team2_injuries = int(stats[2])
                elif stats[1] == 'Sustituciones':
                    stats_team1_subs = int(stats[0])
                    stats_team2_subs = int(stats[2])
                elif stats[1] == 'Faltas':
                    stats_team1_fouls = int(stats[0])
                    stats_team2_fouls = int(stats[2])
                else:
                    print('ERROR GETTING STATISTICS:')
                    print(stats)
                    print()

            return stats_team1_teamname, stats_team1_goals, stats_team1_possession, stats_team1_totalshoots, stats_team1_shootsontarget, stats_team1_shootsofftarget, stats_team1_goalkeepersaves, stats_team1_cornerkicks, stats_team1_offsides, stats_team1_yellowcards, stats_team1_redcards, stats_team1_assists, stats_team1_injuries, stats_team1_subs, stats_team1_fouls, stats_team1_posts, stats_team2_teamname, stats_team2_goals, stats_team2_possession, stats_team2_totalshoots, stats_team2_shootsontarget, stats_team2_shootsofftarget, stats_team2_goalkeepersaves, stats_team2_cornerkicks, stats_team2_offsides, stats_team2_yellowcards, stats_team2_redcards, stats_team2_assists, stats_team2_injuries, stats_team2_subs, stats_team2_fouls, stats_team2_posts

        # STATISTICS
        team1_teamname, team1_goals, team1_possession, team1_totalshoots, team1_shootsontarget, team1_shootsofftarget, team1_goalkeepersaves, team1_cornerkicks, team1_offsides, team1_yellowcards, team1_redcards, team1_assists, team1_injuries, team1_subs, team1_fouls, team1_posts, team2_teamname, team2_goals, team2_possession, team2_totalshoots, team2_shootsontarget, team2_shootsofftarget, team2_goalkeepersaves, team2_cornerkicks, team2_offsides, team2_yellowcards, team2_redcards, team2_assists, team2_injuries, team2_subs, team2_fouls, team2_posts = get_statistics(
            match_statistics)

        # EVENTS
        events_team1, events_team2 = get_events(events_raw)

        def sort_events(team_events):
            card_yellow_player = list()
            card_yellow_minute = list()
            card_red_player = list()
            card_red_minute = list()
            card_red2yellow_player = list()
            card_red2yellow_minute = list()
            goal_player = list()
            goal_minute = list()
            goal_penalty_player = list()
            goal_penalty_minute = list()
            penalty_missed_player = list()
            penalty_missed_minute = list()
            penalty_saved_player = list()
            penalty_saved_minute = list()
            goal_own_player = list()
            goal_own_minute = list()
            goal_cancelled_player = list()
            goal_cancelled_minute = list()
            goal_freekick_player = list()
            goal_freekick_minute = list()
            post_player = list()
            post_minute = list()
            assist_player = list()
            assist_minute = list()
            injury_player = list()
            injury_minute = list()
            subs_in_player = list()
            subs_in_minute = list()
            subs_out_player = list()
            subs_out_minute = list()

            for ev in team_events:
                if ev[0] == 'yellow card':
                    card_yellow_player.append(ev[1])
                    try: card_yellow_minute.append(int(ev[2]))
                    except: card_yellow_minute.append(0)
                elif ev[0] == 'red card (2nd yellow)':
                    card_red2yellow_player.append(ev[1])
                    try: card_red2yellow_minute.append(int(ev[2]))
                    except: card_red2yellow_minute.append(0)
                elif ev[0] == 'red card':
                    card_red_player.append(ev[1])
                    try: card_red_minute.append(int(ev[2]))
                    except: card_red_minute.append(0)
                elif ev[0] == 'goal':
                    goal_player.append(ev[1])
                    try: goal_minute.append(int(ev[2]))
                    except: goal_minute.append(0)
                elif ev[0] == 'goal penalty':
                    goal_penalty_player.append(ev[1])
                    try: goal_penalty_minute.append(int(ev[2]))
                    except: goal_penalty_minute.append(0)
                elif ev[0] == 'goal own':
                    goal_own_player.append(ev[1])
                    try: goal_own_minute.append(int(ev[2]))
                    except: goal_own_minute.append(0)
                elif ev[0] == 'goal cancelled':
                    goal_cancelled_player.append(ev[1])
                    try: goal_cancelled_minute.append(int(ev[2]))
                    except: goal_cancelled_minute.append(0)
                elif ev[0] == 'goal free-kick':
                    goal_freekick_player.append(ev[1])
                    try: goal_freekick_minute.append(int(ev[2]))
                    except: goal_freekick_minute.append(0)
                elif ev[0] == 'missed penalty':
                    penalty_missed_player.append(ev[1])
                    try: penalty_missed_minute.append(int(ev[2]))
                    except: penalty_missed_minute.append(0)
                elif ev[0] == 'saved penalty':
                    penalty_saved_player.append(ev[1])
                    try: penalty_saved_minute.append(int(ev[2]))
                    except: penalty_saved_minute.append(0)
                elif ev[0] == 'post':
                    post_player.append(ev[1])
                    try: post_minute.append(int(ev[2]))
                    except: post_minute.append(0)
                elif ev[0] == 'assist':
                    assist_player.append(ev[1])
                    try: assist_minute.append(int(ev[2]))
                    except: assist_minute.append(0)
                elif ev[0] == 'injury':
                    injury_player.append(ev[1])
                    try: injury_minute.append(int(ev[2]))
                    except: injury_minute.append(0)
                elif ev[0] == 'in':
                    subs_in_player.append(ev[1])
                    try: subs_in_minute.append(int(ev[2]))
                    except: subs_in_minute.append(0)
                elif ev[0] == 'out':
                    subs_out_player.append(ev[1])
                    try: subs_out_minute.append(int(ev[2]))
                    except: subs_out_minute.append(0)
                else:
                    print('ERROR SORTING EVENTS')
                    print(ev)

            return card_yellow_player, card_yellow_minute, card_red_player, card_red_minute, card_red2yellow_player, card_red2yellow_minute, goal_player, goal_minute, goal_penalty_player, goal_penalty_minute, \
                   goal_own_player, goal_own_minute, goal_cancelled_player, goal_cancelled_minute, goal_freekick_player, goal_freekick_minute, post_player, post_minute, assist_player, assist_minute, injury_player, injury_minute, \
                   subs_in_player, subs_in_minute, subs_out_player, subs_out_minute, penalty_missed_player, penalty_missed_minute, penalty_saved_player, penalty_saved_minute

        team1_card_yellow_player, team1_card_yellow_minute, team1_card_red_player, team1_card_red_minute, team1_card_red2yellow_player, team1_card_red2yellow_minute, team1_goal_player, team1_goal_minute, \
        team1_goal_penalty_player, team1_goal_penalty_minute, team1_goal_own_player, team1_goal_own_minute, team1_goal_cancelled_player, team1_goal_cancelled_minute, team1_goal_freekick_player, team1_goal_freekick_minute, \
        team1_post_player, team1_post_minute, team1_assist_player, team1_assist_minute, team1_injury_player, team1_injury_minute, team1_subs_in_player, team1_subs_in_minute, team1_subs_out_player, team1_subs_out_minute, \
        team1_penalty_missed_player, team1_penalty_missed_minute, team1_penalty_saved_player, team1_penalty_saved_minute = sort_events(events_team1)

        team2_card_yellow_player, team2_card_yellow_minute, team2_card_red_player, team2_card_red_minute, team2_card_red2yellow_player, team2_card_red2yellow_minute, team2_goal_player, team2_goal_minute, \
        team2_goal_penalty_player, team2_goal_penalty_minute, team2_goal_own_player, team2_goal_own_minute, team2_goal_cancelled_player, team2_goal_cancelled_minute, team2_goal_freekick_player, team2_goal_freekick_minute, \
        team2_post_player, team2_post_minute, team2_assist_player, team2_assist_minute, team2_injury_player, team2_injury_minute, team2_subs_in_player, team2_subs_in_minute, team2_subs_out_player, team2_subs_out_minute, \
        team2_penalty_missed_player, team2_penalty_missed_minute, team2_penalty_saved_player, team2_penalty_saved_minute = sort_events(events_team2)


        # match_season = str(url[len(url) - 4:])
        match_id = str(season_num + '_' + composed_team_name(
            str(team1_teamname) + '_' + composed_team_name(str(team2_teamname))))

        # DATA DICTIONARY
        match_dict = {
            'match_id': match_id,
            'match_date': str(
                match_date_year + '/' + match_date_month + '/' + match_date_day + ' ' + match_date_hour + ':' + match_date_minute + ':00'),
            'match_season': str(season_year_past)+ '/' +str(season_num),
            'match_matchday': int(matchdays_num_num),
            'match_referee': str(tab_match_teams_referee),
            'match_stadium': str(tab_match_teams_stadium),
            'match_attendance': tab_match_teams_attendance_digit,
            'match_score': tab_match_score,
            'match_team1': str(team1_teamname),
            'match_team1_coach': str(tab_match_teams_team1_coach),
            'match_team1_formation': str(formation_team1),
            'match_team1_align_main': tab_match_teams_aligns_mainalign_team1,
            'match_team1_align_sup': tab_match_teams_aligns_supalign_team1,
            'match_team1_possession': team1_possession,
            'match_team1_goals': int(tab_match_score_team1),
            'match_team1_assists': team1_assists,
            'match_team1_assist_player': team1_assist_player,
            'match_team1_assist_minute': team1_assist_minute,
            'match_team1_goals_player': team1_goal_player,
            'match_team1_goals_minute': team1_goal_minute,
            'match_team1_goal_penalty_player': team1_goal_penalty_player,
            'match_team1_goal_penalty_minute': team1_goal_penalty_minute,
            'match_team1_goal_own_player': team1_goal_own_player,
            'match_team1_goal_own_minute': team1_goal_own_minute,
            'match_team1_goal_own2_player': team2_goal_own_player,
            'match_team1_goal_own2_minute': team2_goal_own_minute,
            'match_team1_goal_cancelled_player': team1_goal_cancelled_player,
            'match_team1_goal_cancelled_minute': team1_goal_cancelled_minute,
            'match_team1_goal_freekick_player': team1_goal_freekick_player,
            'match_team1_goal_freekick_minute': team1_goal_freekick_minute,
            'match_team1_penalty_missed_player': team1_penalty_missed_player,
            'match_team1_penalty_missed_minute': team1_penalty_missed_minute,
            'match_team1_penalty_saved_player': team1_penalty_saved_player,
            'match_team1_penalty_saved_minute': team1_penalty_saved_minute,
            'match_team1_penalty_saved2_player': team2_penalty_saved_player,
            'match_team1_penalty_saved2_minute': team2_penalty_saved_minute,
            'match_team1_totalshoots': team1_totalshoots,
            'match_team1_shootsontarget': team1_shootsontarget,
            'match_team1_shootsofftarget': team1_shootsofftarget,
            'match_team1_goalkeepersaves': team1_goalkeepersaves,
            'match_team1_cornerkicks': team1_cornerkicks,
            'match_team1_offsides': team1_offsides,
            'match_team1_posts': team1_posts,
            'match_team1_post_player': team1_post_player,
            'match_team1_post_minute': team1_post_minute,
            'match_team1_fouls': team1_fouls,
            'match_team1_yellowcards': team1_yellowcards,
            'match_team1_yellowcard_player': team1_card_yellow_player,
            'match_team1_yellowcard_minute': team1_card_yellow_minute,
            'match_team1_redcards': team1_redcards,
            'match_team1_card_red_player': team1_card_red_player,
            'match_team1_card_red_minute': team1_card_red_minute,
            'match_team1_card_red2yellow_player': team1_card_red2yellow_player,
            'match_team1_card_red2yellow_minute': team1_card_red2yellow_minute,
            'match_team1_injuries': team1_injuries,
            'match_team1_injury_player': team1_injury_player,
            'match_team1_injury_minute': team1_injury_minute,
            'match_team1_subs': team1_subs,
            'match_team1_subs_in_player': team1_subs_in_player,
            'match_team1_subs_in_minute': team1_subs_in_minute,
            'match_team1_subs_out_player': team1_subs_out_player,
            'match_team1_subs_out_minute': team1_subs_out_minute,
            'match_team2': str(team2_teamname),
            'match_team2_coach': str(tab_match_teams_team2_coach),
            'match_team2_formation': str(formation_team2),
            'match_team2_align_main': tab_match_teams_aligns_mainalign_team2,
            'match_team2_align_sup': tab_match_teams_aligns_supalign_team2,
            'match_team2_possession': team2_possession,
            'match_team2_goals': int(tab_match_score_team2),
            'match_team2_assists': team2_assists,
            'match_team2_assist_player': team2_assist_player,
            'match_team2_assist_minute': team2_assist_minute,
            'match_team2_goals_player': team2_goal_player,
            'match_team2_goals_minute': team2_goal_minute,
            'match_team2_goal_penalty_player': team2_goal_penalty_player,
            'match_team2_goal_penalty_minute': team2_goal_penalty_minute,
            'match_team2_goal_own_player': team2_goal_own_player,
            'match_team2_goal_own_minute': team2_goal_own_minute,
            'match_team2_goal_own2_player': team1_goal_own_player,
            'match_team2_goal_own2_minute': team1_goal_own_minute,
            'match_team2_goal_cancelled_player': team2_goal_cancelled_player,
            'match_team2_goal_cancelled_minute': team2_goal_cancelled_minute,
            'match_team2_goal_freekick_player': team2_goal_freekick_player,
            'match_team2_goal_freekick_minute': team2_goal_freekick_minute,
            'match_team2_penalty_missed_player': team2_penalty_missed_player,
            'match_team2_penalty_missed_minute': team2_penalty_missed_minute,
            'match_team2_penalty_saved_player': team2_penalty_saved_player,
            'match_team2_penalty_saved_minute': team2_penalty_saved_minute,
            'match_team2_penalty_saved2_player': team1_penalty_saved_player,
            'match_team2_penalty_saved2_minute': team1_penalty_saved_minute,
            'match_team2_totalshoots': team2_totalshoots,
            'match_team2_shootsontarget': team2_shootsontarget,
            'match_team2_shootsofftarget': team2_shootsofftarget,
            'match_team2_goalkeepersaves': team2_goalkeepersaves,
            'match_team2_cornerkicks': team2_cornerkicks,
            'match_team2_offsides': team2_offsides,
            'match_team2_posts': team2_posts,
            'match_team2_post_player': team2_post_player,
            'match_team2_post_minute': team2_post_minute,
            'match_team2_fouls': team2_fouls,
            'match_team2_yellowcards': team2_yellowcards,
            'match_team2_yellowcard_player': team2_card_yellow_player,
            'match_team2_yellowcard_minute': team2_card_yellow_minute,
            'match_team2_redcards': team2_redcards,
            'match_team2_card_red_player': team2_card_red_player,
            'match_team2_card_red_minute': team2_card_red_minute,
            'match_team2_card_red2yellow_player': team2_card_red2yellow_player,
            'match_team2_card_red2yellow_minute': team2_card_red2yellow_minute,
            'match_team2_injuries': team2_injuries,
            'match_team2_injury_player': team2_injury_player,
            'match_team2_injury_minute': team2_injury_minute,
            'match_team2_subs': team2_subs,
            'match_team2_subs_in_player': team2_subs_in_player,
            'match_team2_subs_in_minute': team2_subs_in_minute,
            'match_team2_subs_out_player': team2_subs_out_player,
            'match_team2_subs_out_minute': team2_subs_out_minute
        }
        return match_dict

# url='http://www.resultados-futbol.com/partido/Barcelona/Alaves/2017'
# team1='Barcelona'
# team2='Alaves'
# date='Sat, 10 Sep 2016 20:30:00 +0200'
# matchdata_dict=get_matchdata(url,team1,team2,date)
# print(matchdata_dict)
